// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.

#ifndef __CONFIGURATION_H
#define __CONFIGURATION_H

#include <string>
#include <Tracer.h>

#include "table.h"
#include "token.h"

class Configuration
{
	public :
		typedef struct { string	_name; Token _setting; } Default;

		Configuration(
			const string &				fileName,
			const string &				configurationName,
			unsigned int				numberOfDefaults,
			const Default *				defaults );
		virtual ~Configuration() { PROC ENDPROC }
		const Token & setting( const string & name ) const;
		const TableT & settings() const;

	private :
		TableT defaultSettings(
					unsigned int	numberOfDefaults,
					const Default *	defaults ) const;
		TableT 			_settings;

};


#endif
