// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
/* Revision History
 *
 * $Id: binary_tree.cc,v 1.1 1998/09/25 15:54:26 mbeijers Exp $
 *
 */


/**************************************************************************/
/*                                                                        */
/*  FILENAME                                                              */
/*  ========                                                              */
/*  binary_tree.cc                                                        */
/*                                                                        */
/*                                                                        */
/*  SUBSYSTEM                                                             */
/*  =========                                                             */
/*  XMM SAS - UTILITIES                                                   */
/*                                                                        */
/*                                                                        */
/*  TITLE                                                                 */
/*  =====                                                                 */
/*  Implementation file for BinaryT type.                                 */
/*                                                                        */
/*                                                                        */
/*  AUTHORS                                                               */
/*  =======                                                               */
/*  Mark Thomas                                                           */
/*  CARA Software & Services Ltd                                          */
/*                                                                        */
/*                                                                        */
/*  CONSTRAINTS                                                           */
/*  ===========                                                           */
/*                                                                        */
/*                                                                        */
/*  DESCRIPTION                                                           */
/*  ===========                                                           */
/*  Implementation file for BinaryTree type.                             */
/*                                                                        */
/*                                                                        */
/**************************************************************************/


#include "binary_tree.h"
#include "Tracer.h"


BinaryTree::BinaryTree()
{

	PROC

	_left = 0;
	_right = 0;
	_value = new Token;

	ENDPROC

}


BinaryTree::~BinaryTree()
{
	PROC

	delete _left;
	delete _right;
	delete _value;

	ENDPROC

}


void
BinaryTree::setNode( const Token & token )
{

	PROC

	*_value = token;

	ENDPROC

}


Token
BinaryTree::node() const
{
	PROC
	RETURN *_value;

}


void
BinaryTree::setRight( const BinaryTree & tree )
{
	PROC

	delete _right;

	_right = new BinaryTree();
	*_right = tree;

	ENDPROC
}


BinaryTree
BinaryTree::right() const
{
	PROC
	RETURN *_right;

}


void
BinaryTree::setLeft( const BinaryTree & tree )
{
	PROC

	delete _left;

	_left = new BinaryTree();
	*_left = tree;

	ENDPROC

}


BinaryTree
BinaryTree::left() const
{
	PROC
	RETURN *_left;

}


BinaryTree
BinaryTree::operator=( const BinaryTree & tree )
{
	PROC

	*_value = *tree._value;
	delete _left;
	_left = 0;
	delete _right;
	_right = 0;

	if( tree._left != 0 )
	{
		_left = new BinaryTree;
		*_left = *tree._left;

	} /* if */

	if( tree.right != 0 )
	{
		_right = new BinaryTree;
		*_right = *tree._right;

	} /* if */

	RETURN *this;

}


BinaryTree::BinaryTree( const BinaryTree & tree )
{

	PROC

	_value = tree._value;

	if( tree.left != 0 )
	{
		_left = new BinaryTree;
		*_left = *tree._left;

	}
	else
	{
		_left = 0;

	} /* if */

	if( tree._right != 0 )
	{
		_right = new BinaryTree;
		*_right = *tree._right;

	}
	else
	{
		_right = 0;

	} /* if */


	ENDPROC

}


