// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
/* Revision History
 *
 * $Log: debug.h,v $
 * Revision 1.4  2002/09/17 09:38:23  gvacanti
 * Committed through make
 *
 * Revision 1.2  2002/06/11 09:18:06  jbakker
 * Committed through make
 *
 * Revision 1.1  1998/09/25 15:54:27  mbeijers
 * Split from package utils.
 *
 * Revision 1.1  1997/09/09 13:24:08  mbeijers
 * Moved sources to src subdirectory.
 *
 * Revision 1.1  1997/08/22 13:40:15  mthomas
 * Reference: First Check-in
 * Software Change:
 * 	First stable prototype.
 *
 *
 * $Id: debug.h,v 1.4 2002/09/17 09:38:23 gvacanti Exp $
 *
 */
/*
	File:	debug.h

	Title:	Header file for debug and log facility

	Author:	M Thomas

	Date:	03/06/97

*/


#ifndef __DEBUG_H
#define __DEBUG_H 


#include <cstdio>

void DebugEnterFunction( char *, char * );
void DebugExitFunction( char * );
void DebugPrintf( char *, char *, ... );

#ifndef DEBUG_OFF

#define DEBUG_ENTER_FUNCTION(ThisFunction) \
		 DebugEnterFunction (__FILE__,__PRETTY_FUNCTION__) 
#define DEBUG_EXIT_FUNCTION DebugExitFunction(__FILE__) 
#define DEBUG_PRINTF(S) DebugPrintf(__FILE__,S)
#define DEBUG_PRINTF_1(S,P1) DebugPrintf(__FILE__,S,P1)
#define DEBUG_PRINTF_2(S,P1,P2) DebugPrintf(__FILE__,S,P1,P2)
#define DEBUG_PRINTF_3(S,P1,P2,P3) DebugPrintf(__FILE__,S,P1,P2,P3)
#define DEBUG_PRINTF_4(S,P1,P2,P3,P4) DebugPrintf(__FILE__,S,P1,P2,P3,P4)
#define DEBUG_PRINTF_5(S,P1,P2,P3,P4,P5) DebugPrintf(__FILE__,S,P1,P2,P3,P4,P5)
#define DEBUG_PRINTF_6(S,P1,P2,P3,P4,P5,P6) DebugPrintf(__FILE__,S,P1,P2,P3,P4,P5,P6)
#define DEBUG_PRINTF_7(S,P1,P2,P3,P4,P5,P6,P7) DebugPrintf(__FILE__,S,P1,P2,P3,P4,P5,P6,P7)

#else

#define DEBUG_INITIALISE(Required,FileID,FileLevel)
#define DEBUG_DESTROY
#define DEBUG_SET_LOG_FILE(Required,FileID,FileLevel)
#define DEBUG_ENTER_FUNCTION(ThisFunction)
#define DEBUG_EXIT_FUNCTION
#define DEBUG_PRINTF(S)
#define DEBUG_PRINTF_1(S,P1)
#define DEBUG_PRINTF_2(S,P1,P2)
#define DEBUG_PRINTF_3(S,P1,P2,P3)
#define DEBUG_PRINTF_4(S,P1,P2,P3,P4)
#define DEBUG_PRINTF_5(S,P1,P2,P3,P4,P5)
#define DEBUG_PRINTF_6(S,P1,P2,P3,P4,P5,P6)
#define DEBUG_PRINTF_7(S,P1,P2,P3,P4,P5,P6,P7)


#endif /* DEBUG_OFF */
#endif /* __DEBUG_H */

