// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.

#include "scanner.h"
#include "parsing.h"
#include "table.h"
#include "dal_c_lookups.h"
#include "Interpreter.h"

//#include "PerlInterpreter.h"
//#include "param.h"
//#include "SasFileLocator.h"
//#include "dscript.h"


//static string systemPerllib = "systemPerllib";
//static string perllib = "perllib";
//static string infile = "infile";
//static string _optional_ = "_optional_";


static void
test( const string& fileName )
{
	// *************************************************
	// Initialise the Perl interpreter so that deceit.pl
	// perl source file is read.
	// The default is used if the user has not specified
	// it on the command line.
	// *************************************************
	//if( stringParameter( perllib ) == _optional_ )
	//{
	//	perlInterpreter.initialise( fileLocator.locate( stringParameter( systemPerllib )));
	//}
	//else
	//{
	//	perlInterpreter.initialise( stringParameter( perllib ));
	//} // if

	//string fileName = stringParameter( infile );

	ScannerT	scanner( fileName );
	TableT		lookupTable;
	//perlInterpreter.addFunctionsToTable( lookupTable );
	interpreter.addFunctionsToTable( lookupTable );
	lookupTable.append( dalCLookups() );

	while( !scanner.EndOfFile() )
	{
		Token::BTree expression = ParseStatement( scanner );
		interpreter.EvaluateExpression( expression, lookupTable );

	} // while

}


int
main( int argc, char** argv)
{
	for( int i = 1; i < argc; ++i )
	{
		test( argv[ i ] );
	} // for

	return 0;
}


